# -*- coding: utf-8 -*-
from sys import version
from setuphelpers import *

def install():
    # Initializing variables
    package_version = control.version.split("-")[0]
    dir_name = "ImDiskTk%s" % package_version
    bin_path = makepath(basedir, dir_name, "config.exe")
    app_name = control.name
    if control.architecture == "x64":
        win64app = True
    else:
        win64app = False

    # Installing the software
    print("Installing: %s (%s)" % (app_name, package_version))
    install_exe_if_needed(
        bin_path,
        silentflags="/fullsilent",
        key="ImDiskApp",
        min_version=package_version,
    )

    # Adding "native" silent uninstall
    for uninstall in installed_softwares(uninstallkey="ImDiskApp"):
        silent_uninstall_cmd = uninstall["uninstall_string"].replace("/u", "/silentuninstall")
        register_uninstall("ImDiskApp", quiet_uninstall_string=silent_uninstall_cmd, win64app=win64app)

