# -*- coding: utf-8 -*-
from setuphelpers import *
import json


def update_package():
    # Declaring local variables
    bin_contains = "ImDiskTk"
    result = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name
    project_repo = "imdisk-toolkit"
    api_url = "https://sourceforge.net/projects/%s/best_release.json" % project_repo
    if control.architecture == "x64":
        latest_bin = "ImDiskTk-x64.zip"
    else:
        latest_bin = "ImDiskTk.zip"

    # Getting latest version information from official sources
    print("API used is: %s" % api_url)
    json_load = json.loads(wgets(api_url, proxies=proxies))
    for download in json_load["platform_releases"]:
        if bin_contains in json_load["platform_releases"][download]["filename"]:
            download_url = json_load["platform_releases"][download]["url"].replace("ImDiskTk-x64.zip", latest_bin)
            version = json_load["platform_releases"][download]["filename"].split("/")[-2]
            break

    print("Latest %s version is: %s" % (app_name, version))
    print("Download URL is: %s" % download_url)

    # Downloading latest binaries
    dir_name = "ImDiskTk%s" % version
    dir_name_temp = latest_bin.split(".")[0]

    if isdir(dir_name):
        remove_tree(dir_name)
    if isdir(dir_name_temp):
        remove_tree(dir_name_temp)
    if isfile(latest_bin):
        remove_file(latest_bin)

    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)

        unzip(latest_bin)
        unzip_with_7zip(makepath(dir_name_temp, dir_name, "files.cab"), target=dir_name)

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        result = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.version = "%s-%s" % (Version(version), control.version.split("-", 1)[-1])
    # control.set_software_version(version)
    control.save_control_to_wapt()

    # Deleting outdated binaries
    remove_outdated_binaries("all", list_extensions="zip")
    if isdir(dir_name_temp):
        remove_tree(dir_name_temp)

    # Validating or not update-package-sources
    return result
